import urllib2, threading, es, time, os, os.path, zipfile, popuplib, zlib

info = es.AddonInfo()
info.name	 = "Ojiiupdater"
info.version  = "Beta 3"
info.url	  = "http://addons.eventscripts.com/addons/view/ojiiupdater"
info.author   = "Ojii"
info.basename = "ojiiupdater"

'''
Ojiiupdater by Ojii, Beta 3

Tested commands:
INSERT
REMOVE
CHANGE
ESAM
URL
CREATEZIP
CREATEURL
DELETE
MOVE
COPY

Tested classes:

update
checkesam
checkversion
popup

Many thanks to everyone helping me on the IRC channel
'''

class update():
	def __init__(self, info, updateurl):
		self.starttime = time.clock()
		es.dbgmsg(1, '[OU] Initializing Ojiiupdater')
		if 'version' and 'basename' and 'url' and 'name' in info:
			self.updateurl = updateurl
			self.scriptversion = info['version']
			self.script = info['basename']
			self.esamurl = info['url'].replace('addons/view','addons/download')
			self.name = info['name']
			self.scriptpath = es.getAddonPath(self.script).replace('\\','/') + '/'
			self.scriptfile =  self.scriptpath + self.script + '.py'
			self.tempfile = self.scriptpath + 'ou_temp/tempupdatefile'
			self.rootpath = es.getAddonPath('').replace('\\','/').replace('addons/eventscripts','')
			self.okay = 1
			self.content = ''
			self.filename = ''
			self.updatedict = {}
			self.updatelines = []
		else:
			self.okay = 0
		self.run()

	def run(self):
		es.dbgmsg(0, '[OU] Starting update of: ' + self.name)
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		if self.okay == 1:
			self.backup()
			self.read_script_file()
		else:
			es.dbgmsg(0, '[OU] ERROR! Insufficent information!')

	def read_script_file(self):
		es.dbgmsg(1, '[OU] Reading current script file')
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		tempfile = open(self.scriptfile, 'r')
		self.scriptlines = []
		templist = tempfile.readlines()
		x = 0
		total = len(templist)
		for temp in templist:
			x = x + 1
			es.dbgmsg(1, '[OU] Reading script file... (' + str(x) + '/' + str(total) + ')')
			self.scriptlines.append(temp.replace('\n',''))
		tempfile.close()
		self.read_update_file()

	def read_update_file(self):
		es.dbgmsg(1, '[OU] Reading update file')
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		content = urllib2.urlopen(self.updateurl).read().replace('\r','')
		self.content = []
		for temp in content.splitlines():
			self.content.append(temp.replace('\n',''))
		es.dbgmsg(1, '[OU] Downloaded updatecontent')
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		lineversion = []
		total = len(self.content)
		x = 0
		for line in self.content:
			x = x + 1
			es.dbgmsg(1, '[OU] Reading content... (' + str(x) + '/' + str(total) + ')')
			if line.startswith('V'):
				end = line.find(' ')
				lineversion.append(line[1:end])
		x = 0
		for line in lineversion:
			es.dbgmsg(1, '[OU] Reading lines... (' + str(x + 1) + '/' + str(total) + ')')
			es.dbgmsg(1,'[OU_DBG] updatedict: ' + str(self.updatedict))
			if line > self.scriptversion:
				if self.updatedict.has_key(line):
					es.dbgmsg(1,'[OU_DBG] updatedict: ' + str(self.updatedict[line]))
					self.updatedict[line].append(self.content[x][end + 1:])
				else:
					self.updatedict[line] = [self.content[x][end + 1:]]
			x = x + 1
		if len(self.updatedict) == 0:
			es.dbgmsg(0,'[OU] No updates available')
			duration = time.clock() - self.starttime
			es.dbgmsg(1, '[OU] Time: ' + str(duration))
		else:
			self.check_esam()

	def check_esam(self):
		es.dbgmsg(1,'[OU] Checking for ESAM Update')
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		searchlines = []
		self.esam = None
		for version in self.updatedict:
			searchlines = self.updatedict[version]
			for line in searchlines:
				if line.startswith('ESAM'):
					if self.esam == None:
						self.esam = version
					elif self.esam < version:
						self.easm = version
		if self.esam == None:
			self.update()
		else:
			self.esam_update()

	def esam_update(self):
		es.dbgmsg(1, '[OU] Starting ESAM Update...')
		update.backup(self)
		es.dbgmsg(1, '[OU] Starting download...')
		url = urllib2.urlopen(self.esamurl)
		es.dbgmsg(1, '[OU] Download complete...')
		if not os.path.lexists(self.scriptpath + 'ou_temp/'):
			os.mkdir(self.scriptpath + 'ou_temp/')
		dlcontent = url.read()
		f = open(self.tempfile,'wb')
		f.write(dlcontent)
		f.close()
		if zipfile.is_zipfile(self.tempfile):
			self.esam_zipupdate()
		else:
			newdata = dlcontent.replace('\r','')
			es.dbgmsg(1, '[OU] Writing file...')
			newfile = open(self.scriptfile,'w')
			newfile.write(newdata)
			newfile.close()
			es.dbgmsg(1, '[OU] ESAM Update done...')
			es.dbgmsg(1, '[OU] Reloading Script...')
			es.dbgmsg(1, '[OU] Update completed...')
			es.reload(self.script)
			duration = time.clock() - self.starttime
			es.dbgmsg(1, '[OU] Time: ' + str(duration))
		
	def esam_zipupdate(self):
		es.dbgmsg(1,'[OU] Starting zip update')
		z = zipfile.ZipFile(self.tempfile,'r')
		for name in z.namelist():
			if name.endswith(self.script + '.py'):
				data = z.read(name)
				data = data.replace('\r','')
				f = open(self.scriptfile,'w')
				f.write(data)
				f.close()
		if self.check_root(z):
			for name in z.namelist():
				if name.count('.') == 0:
					if not os.path.lexists(self.rootpath + name):
						os.mkdir(self.rootpath + name)
				else:
					data = z.read(name)
					f = open(self.rootpath + name,'w')
					f.write(data)
					f.close()
		else:
			es.dbgmsg(0,'[OU_ERROR] Zipfile does not have standart folder structure!')
			es.dbgmsg(0,'[OU_ERROR] No files but the scriptfiles have been edited or created')
		es.dbgmsg(0,'[OU] Update completed...')
		duration = time.clock() - self.starttime
		es.dbgmsg(0,'[OU] Update completed in : ' + str(duration) + ' seconds')
		es.reload(self.script)
	def check_root(self,z):
		if 'addons/' in z.namelist():
			return True
		elif 'Addons/' in z.namelist():
			return True
		elif 'ADDONS/' in z.namelist():
			return True
		else:
			return False
	def update(self):
		es.dbgmsg(1,'[OU] Starting main update process')
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		self.updatelines = []
		onlinelines = []
		for version in self.updatedict:
			total = str(len(self.scriptlines))
			nr = 0
			for line in self.scriptlines:
				es.dbgmsg(1, '[OU] Cleaning scriptlines...(' + str(nr + 1) + '/' + total + ')')
				if line == '[[[REMOVE]]]':
					del self.scriptlines[nr]
				nr = nr + 1
			es.dbgmsg(1, '[OU] Updating to version: ' + version)
			self.updatelines = self.updatedict[version]
			total = len(self.updatedict)
			x = 0
			for line in self.updatelines:
				es.dbgmsg(1, '[OU] Processing self.updatelines (' + version + ')... (' + str(x + 1) + '/' + str(total) + ')')	
				if line.startswith('URL'):
					start = line.find(' ') + 1
					link = line[start:]
					content = urllib2.urlopen(link).read()
					content = content.replace('\r','')
					self.updatedict[version] = content.splitlines()
					update.update(self)
				elif line.startswith('REMOVE'):
					start = line.find(' ') + 1
					linenr = int(line[start:]) - 1
					self.scriptlines[linenr] = '[[[REMOVE]]]'
				elif line.startswith('INSERT'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					linenr = line[start:end]
					start = line.find(' ', end) + 1
					newline = line[start:]
					if linenr == 'END':
						self.scriptlines.append(newline)
					else:
						linenr = int(linenr) - 1
						self.scriptlines.insert(linenr, newline)
				elif line.startswith('CHANGE'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					linenr = int(line[start:end]) - 1
					start = line.find(' ', end) + 1
					changedline = line[start:]
					del self.scriptlines[linenr]
					self.scriptlines.insert(linenr, changedline)
				elif line.startswith('CREATE '):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					self.filename = line[start:end]
					self.content = line[end + 1:]
					self.create()
				elif line.startswith('CREATEURL'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					self.filename = line[start:end]
					url = line[end + 1:]
					content = urllib2.urlopen(url).read()
					self.content = content.replace('\r','')
					self.create()
				elif line.startswith('CREATEZIP'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					self.filename = line[start:end]
					url = line[end + 1:]
					self.createzip(url)
				elif line.startswith('DELETE'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					filename = line[start:end]
					if filename.startswith('_ES_'):
						filepath = es.getAddonPath('').replace('\\','/') + filename[4:]
					elif filename.startswith('_SCRIPT_'):
						filepath = es.getAddonPath(self.script).replace('\\','/') + filename[8:]
					elif filename.startswith('_ROOT_'):
						path = es.getAddonPath('').replace('\\','/')
						filepath = path.replace('addons/eventscripts/',filename[6:])
					try:
						os.remove(filepath)
					except:
						es.dbgmsg(1,'[OU] Failed to remove ' + filepath)
				elif line.startswith('COPY'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					sourcefile = line[start:end]
					start = line.find(' ', end) + 1
					destfile = line[start:]
					if sourcefile.startswith('_ES_'):
						sourcepath = es.getAddonPath('').replace('\\','/') + sourcefile[4:]
					elif sourcefile.startswith('_SCRIPT_'):
						sourcepath = es.getAddonPath(self.script).replace('\\','/') + sourcefile[8:]
					elif sourcefile.startswith('_ROOT_'):
						path = es.getAddonPath('').replace('\\','/')
						sourcepath = path.replace('addons/eventscripts/',sourcefile[6:])
					if destfile.startswith('_ES_'):
						destpath = es.getAddonPath('').replace('\\','/') + destfile[4:]
					elif destfile.startswith('_SCRIPT_'):
						destpath = es.getAddonPath(self.script).replace('\\','/') + destfile[8:]
					elif destfile.startswith('_ROOT_'):
						path = es.getAddonPath('').replace('\\','/')
						destpath = path.replace('addons/eventscripts/',destfile[6:])
					source = open(sourcepath, 'r')
					content = source.read()
					source.close()
					end = destpath.rfind('/') + 1
					if not os.path.lexists(destpath[:end]):
						os.mkdir(destpath[:end])
					destiny = open(destpath, 'w')
					destiny.write(content)
					destiny.close()
				elif line.startswith('MOVE'):
					start = line.find(' ') + 1
					end = line.find(' ', start)
					sourcefile = line[start:end]
					start = line.find(' ', end) + 1
					destfile = line[start:]
					if sourcefile.startswith('_ES_'):
						sourcepath = es.getAddonPath('').replace('\\','/') + sourcefile[4:]
					elif sourcefile.startswith('_SCRIPT_'):
						sourcepath = es.getAddonPath(self.script).replace('\\','/') + sourcefile[8:]
					elif sourcefile.startswith('_ROOT_'):
						path = es.getAddonPath('').replace('\\','/')
						sourcepath = path.replace('addons/eventscripts/',sourcefile[6:])
					if destfile.startswith('_ES_'):
						destpath = es.getAddonPath('').replace('\\','/') + destfile[4:]
					elif destfile.startswith('_SCRIPT_'):
						destpath = es.getAddonPath(self.script).replace('\\','/') + destfile[8:]
					elif destfile.startswith('_ROOT_'):
						path = es.getAddonPath('').replace('\\','/')
						destpath = path.replace('addons/eventscripts/',destfile[6:])
					end = destpath.rfind('/') + 1
					if not os.path.lexists(destpath[:end]):
						os.mkdir(destpath[:end])
					os.rename(sourcepath,destpath)
				else:
					es.dbgmsg(1,'[OU] Error in line ' + x + ' in update to version ' + version + ': Invalid Syntax!')
			y = 0
			for line in self.scriptlines:
				if line.startswith('info.version'):
					del self.scriptlines[y]
					self.scriptlines.insert(y, 'info.version = "' + version + '"')
					es.dbgmsg(1,'[OU] Updated info.version')
				y = y + 1
			x = x + 1
		self.write_script_file()

	def create(self):
		start = self.filename.rfind('/') + 1
		es.dbgmsg(1,'[OU] Creating file: ' + self.filename[start:])
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		filename = self.filename
		if filename.startswith('_ES_'):
			filepath = es.getAddonPath('').replace('\\','/') + filename[4:]
		elif filename.startswith('_SCRIPT_'):
			filepath = es.getAddonPath(self.script).replace('\\','/') + filename[8:]
		elif filename.startswith('_ROOT_'):
			path = es.getAddonPath('').replace('\\','/')
			filepath = path.replace('addons/eventscripts/',filename[6:])
		end = filepath.rfind('/') + 1
		path = filepath[:end]
		if not os.path.lexists(path):
			os.mkdir(path)
		tempfile = open(filepath, 'w')
		tempfile.write(self.content.strip("'"))
		tempfile.close()
	def createzip(self,url):
		url = urllib2.urlopen(url)
		if not os.path.lexists(self.scriptpath + 'ou_temp/'):
			os.mkdir(self.scriptpath + 'ou_temp/')
		dlcontent = url.read()
		f = open(self.tempfile,'wb')
		f.write(dlcontent)
		f.close()
		z = zipfile.ZipFile(self.tempfile,'r')
		if update.check_root(self,z):
			for name in z.namelist():
				if name.count('.') == 0:
					if not os.path.lexists(self.rootpath + name):
						os.mkdir(self.rootpath + name)
				else:
					data = z.read(name)
					f = open(self.rootpath + name,'w')
					f.write(data.replace('\r',''))
					f.close()
		else:
			es.dbmsg(0,'[OU_ERROR] Invalid zip file structure!')
	def write_script_file(self):
		es.dbgmsg(1,'[OU] Writing new script file')
		duration = time.clock() - self.starttime
		es.dbgmsg(1, '[OU] Time: ' + str(duration))
		content = ''
		total = len(self.scriptlines)
		x = 0
		for line in self.scriptlines:
			x = x + 1
			es.dbgmsg(1, '[OU] Preparing lines for writing process... (' + str(x) + '/' + str(total) + ')')
			if x == len(self.scriptlines):
				if line != '[[[REMOVE]]]':
					content = content + line
			elif line!= '[[[REMOVE]]]':
				content = content + line + '\n'
		tempfile = open(self.scriptfile, 'w')
		es.dbgmsg(1, '[OU] Writing lines...')
		tempfile.write(content)
		es.dbgmsg(1, '[OU] Lines written...')
		tempfile.close()
		es.dbgmsg(1,'[OU] Reloading script')
		es.reload(self.script)
		es.dbgmsg(0,'[OU] Update complete')
		duration = time.clock() - self.starttime
		es.dbgmsg(0,'[OU] Update completed in : ' + str(duration) + ' seconds')
	
	def backup(self):
		es.dbgmsg(1, '[OU] Starting  Backup...')
		tempfile = open(self.scriptfile, 'r')
		content = tempfile.read()
		tempfile.close()
		backuppath = es.getAddonPath(self.script).replace('\\','/') + '/ojiiupdater_backup/'			
		if not os.path.lexists(backuppath):
			os.mkdir(es.getAddonPath(self.script).replace('\\','/') + '/ojiiupdater_backup/')
		backupfile = open(backuppath  + self.script + '_' + self.scriptversion + '.backup', 'w')
		es.dbgmsg(1, '[OU] Writing backup file...')
		backupfile.write(content)
		backupfile.close()
		es.dbgmsg(1, '[OU] Backup complete...')
		
class checkesam():
	def __init__(self, info):
		es.dbgmsg(1, '[OU] Checking for new scriptversion on ESAM...')
		if 'version' and 'basename' in info:
			self.scriptversion = info['version']
			self.script = info['basename']
			self.okay = 1
		else:
			self.okay = 0
		self.run()
		
	def run(self):
		if self.okay == 1:
			onlineversion = urllib2.urlopen('http://addons.eventscripts.com/addons/chklatestver/' + self.script).read()
			self.latest_version = onlineversion
			if onlineversion > self.scriptversion:
				self.newversion = 1
			else:
				self.newversion = 0
		else:
			es.dbgmsg(0, '[OU] Error getting information from the script...')
			
class checkversion():
	def __init__(self, info, updateurl):
		es.dbgmsg(1, '[OU] Checking for new scriptversion in the updatefile... (' + updateurl + ')')
		if 'version' and 'basename' in info:
			self.scriptversion = info['version']
			self.script = info['basename']
			self.updateurl = updateurl
			self.okay = 1
		else:
			self.okay = 0
		self.run()
	def run(self):
		if self.okay ==1:
			online = urllib2.urlopen(self.updateurl).readlines()
			latest = online[len(online) - 1]
			end = latest.find(' ')
			latest = latest[:end].replace('V','')
			self.latest_version = latest
			if latest > self.scriptversion:
				self.newversion = 1
			else:
				self.newversion = 0
		else:
			es.dbgmsg(0, '[OU] Error getting information from the script...')
			
class popup():
	def __init__(self, info, updateurl, userid):
		es.dbgmsg(0,'DBG: popup init')
		if 'version' and 'basename' and 'url' and 'name' in info:
			self.updateurl = updateurl
			self.scriptversion = info['version']
			self.script = info['basename']
			self.esamurl = info['url'].replace('addons/view','addons/download')
			self.name = info['name']
			self.scriptpath = es.getAddonPath(self.script).replace('\\','/') + '/'
			self.scriptfile =  self.scriptpath + self.script + '.py'
			self.info = info
			self.userid = userid
			self.okay = 1
		else:
			self.userid = userid
			self.okay = 0
		self.run()
	
	def run(self):
		if self.okay == 1:
			self.send_popup()
		else:
			es.tell(self.userid,'[OU] Not enough information given by info.')
	
	def check(self):
		online = urllib2.urlopen(self.updateurl).readlines()
		latest = online[len(online) - 1]
		end = latest.find(' ')
		latest_version = latest[:end].replace('V','')
		if latest_version > self.scriptversion:
			return [1,latest_version]
		else:
			return [0,latest_version]
	
	def send_popup(self):
		self.popup = popuplib.easymenu('update_popup','_popup_choice',self.mainpopup)
		self.popup.settitle('Ojiiupdater for ' + self.name)
		self.popup.addoption('check','Check for new versions')
		self.popup.addoption('rollback','Restore older version')
		self.popup.addoption('update','Update')
		self.popup.send(self.userid)
		
	def mainpopup(self, userid, choice, menuname):
		if choice == 'check':
			self.checklist = self.check()
			self.send_checkpopup()
		elif choice == 'rollback':
			self.send_rollbackpopup()
		else:
			update.__init__(self.info,self.updateurl)
			
	def send_checkpopup(self):
		self.checkpopup = popuplib.easymenu('check_popup','_popup_choice',self.checkpopup)
		new = self.checklist[0]
		latest = self.checklist[1]
		if new == 1:
			self.checkpopup.settitle('There is a new version for ' + self.name + ': ' + latest)
			self.checkpopup.addoption('update','Update!')
		else:
			self.checkpopup.settitle('Your version of ' + self.name + 'is up to date.')
		self.checkpopup.send(self.userid)
		
	def checkpopup(self,userid,choice,menuname):
		if choice == 'update':
			update.__init__(self.info,self.updateurl)
		
	def send_rollbackpopup(self):
		self.backuppath = es.getAddonPath(self.script).replace('\\','/') + '/ojiiupdater_backup/'
		backuplist = []
		for backup in os.listdir(self.backuppath):
			backuplist.append(backup.replace(self.script + '_','').replace('.backup',''))
		backuplist.sort()
		self.rollbackpopup = popuplib.easymenu('rollback_popup','_popup_choice',self.really)
		self.rollbackpopup.settitle('Choose a version to restore:')
		if backuplist == []:
			self.rollbackpopup.addoption('none','No backup found')
		else:
			for backup in backuplist:
				self.rollbackpopup.addoption(backup,'Version ' + backup)
		self.rollbackpopup.send(self.userid)
		
	def really(self,userid,choice,menuname):
		if not choice == 'none':
			self.rollbackversion = choice
			self.reallypopup = popuplib.easymenu('really_popup','_popup_choice',self.rollback)
			self.reallypopup.settitle('Are you sure?')
			self.reallypopup.addoption('yes','Yes')
			self.reallypopup.addoption('no','No')
			self.reallypopup.send(userid)
		
	def rollback(self,userid,choice,menuname):
		if choice == 'yes':
			f = open(self.backuppath + self.script + '_' + self.rollbackversion + '.backup', 'r')
			oldversion = f.read()
			f.close()
			f = open(self.scriptfile,'w')
			f.write(oldversion)
			f.close()
			es.reload(self.script)